/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// THIS CODE IS AUTOMATICALLY GENERATED.  DO NOT EDIT.

package org.apache.kafka.common.message;

import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.ArrayNode;
import com.fasterxml.jackson.databind.node.IntNode;
import com.fasterxml.jackson.databind.node.JsonNodeFactory;
import com.fasterxml.jackson.databind.node.NullNode;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.fasterxml.jackson.databind.node.ShortNode;
import com.fasterxml.jackson.databind.node.TextNode;
import java.util.ArrayList;
import org.apache.kafka.common.protocol.MessageUtil;

import static org.apache.kafka.common.message.ListPartitionReassignmentsResponseData.*;

public class ListPartitionReassignmentsResponseDataJsonConverter {
    public static ListPartitionReassignmentsResponseData read(JsonNode _node, short _version) {
        ListPartitionReassignmentsResponseData _object = new ListPartitionReassignmentsResponseData();
        JsonNode _throttleTimeMsNode = _node.get("throttleTimeMs");
        if (_throttleTimeMsNode == null) {
            throw new RuntimeException("ListPartitionReassignmentsResponseData: unable to locate field 'throttleTimeMs', which is mandatory in version " + _version);
        } else {
            _object.throttleTimeMs = MessageUtil.jsonNodeToInt(_throttleTimeMsNode, "ListPartitionReassignmentsResponseData");
        }
        JsonNode _errorCodeNode = _node.get("errorCode");
        if (_errorCodeNode == null) {
            throw new RuntimeException("ListPartitionReassignmentsResponseData: unable to locate field 'errorCode', which is mandatory in version " + _version);
        } else {
            _object.errorCode = MessageUtil.jsonNodeToShort(_errorCodeNode, "ListPartitionReassignmentsResponseData");
        }
        JsonNode _errorMessageNode = _node.get("errorMessage");
        if (_errorMessageNode == null) {
            throw new RuntimeException("ListPartitionReassignmentsResponseData: unable to locate field 'errorMessage', which is mandatory in version " + _version);
        } else {
            if (_errorMessageNode.isNull()) {
                _object.errorMessage = null;
            } else {
                if (!_errorMessageNode.isTextual()) {
                    throw new RuntimeException("ListPartitionReassignmentsResponseData expected a string type, but got " + _node.getNodeType());
                }
                _object.errorMessage = _errorMessageNode.asText();
            }
        }
        JsonNode _topicsNode = _node.get("topics");
        if (_topicsNode == null) {
            throw new RuntimeException("ListPartitionReassignmentsResponseData: unable to locate field 'topics', which is mandatory in version " + _version);
        } else {
            if (!_topicsNode.isArray()) {
                throw new RuntimeException("ListPartitionReassignmentsResponseData expected a JSON array, but got " + _node.getNodeType());
            }
            ArrayList<OngoingTopicReassignment> _collection = new ArrayList<OngoingTopicReassignment>();
            _object.topics = _collection;
            for (JsonNode _element : _topicsNode) {
                _collection.add(OngoingTopicReassignmentJsonConverter.read(_element, _version));
            }
        }
        return _object;
    }
    public static JsonNode write(ListPartitionReassignmentsResponseData _object, short _version) {
        ObjectNode _node = new ObjectNode(JsonNodeFactory.instance);
        _node.set("throttleTimeMs", new IntNode(_object.throttleTimeMs));
        _node.set("errorCode", new ShortNode(_object.errorCode));
        if (_object.errorMessage == null) {
            _node.set("errorMessage", NullNode.instance);
        } else {
            _node.set("errorMessage", new TextNode(_object.errorMessage));
        }
        ArrayNode _topicsArray = new ArrayNode(JsonNodeFactory.instance);
        for (OngoingTopicReassignment _element : _object.topics) {
            _topicsArray.add(OngoingTopicReassignmentJsonConverter.write(_element, _version));
        }
        _node.set("topics", _topicsArray);
        return _node;
    }
    
    public static class OngoingPartitionReassignmentJsonConverter {
        public static OngoingPartitionReassignment read(JsonNode _node, short _version) {
            OngoingPartitionReassignment _object = new OngoingPartitionReassignment();
            JsonNode _partitionIndexNode = _node.get("partitionIndex");
            if (_partitionIndexNode == null) {
                throw new RuntimeException("OngoingPartitionReassignment: unable to locate field 'partitionIndex', which is mandatory in version " + _version);
            } else {
                _object.partitionIndex = MessageUtil.jsonNodeToInt(_partitionIndexNode, "OngoingPartitionReassignment");
            }
            JsonNode _replicasNode = _node.get("replicas");
            if (_replicasNode == null) {
                throw new RuntimeException("OngoingPartitionReassignment: unable to locate field 'replicas', which is mandatory in version " + _version);
            } else {
                if (!_replicasNode.isArray()) {
                    throw new RuntimeException("OngoingPartitionReassignment expected a JSON array, but got " + _node.getNodeType());
                }
                ArrayList<Integer> _collection = new ArrayList<Integer>();
                _object.replicas = _collection;
                for (JsonNode _element : _replicasNode) {
                    _collection.add(MessageUtil.jsonNodeToInt(_element, "OngoingPartitionReassignment element"));
                }
            }
            JsonNode _addingReplicasNode = _node.get("addingReplicas");
            if (_addingReplicasNode == null) {
                throw new RuntimeException("OngoingPartitionReassignment: unable to locate field 'addingReplicas', which is mandatory in version " + _version);
            } else {
                if (!_addingReplicasNode.isArray()) {
                    throw new RuntimeException("OngoingPartitionReassignment expected a JSON array, but got " + _node.getNodeType());
                }
                ArrayList<Integer> _collection = new ArrayList<Integer>();
                _object.addingReplicas = _collection;
                for (JsonNode _element : _addingReplicasNode) {
                    _collection.add(MessageUtil.jsonNodeToInt(_element, "OngoingPartitionReassignment element"));
                }
            }
            JsonNode _removingReplicasNode = _node.get("removingReplicas");
            if (_removingReplicasNode == null) {
                throw new RuntimeException("OngoingPartitionReassignment: unable to locate field 'removingReplicas', which is mandatory in version " + _version);
            } else {
                if (!_removingReplicasNode.isArray()) {
                    throw new RuntimeException("OngoingPartitionReassignment expected a JSON array, but got " + _node.getNodeType());
                }
                ArrayList<Integer> _collection = new ArrayList<Integer>();
                _object.removingReplicas = _collection;
                for (JsonNode _element : _removingReplicasNode) {
                    _collection.add(MessageUtil.jsonNodeToInt(_element, "OngoingPartitionReassignment element"));
                }
            }
            return _object;
        }
        public static JsonNode write(OngoingPartitionReassignment _object, short _version) {
            ObjectNode _node = new ObjectNode(JsonNodeFactory.instance);
            _node.set("partitionIndex", new IntNode(_object.partitionIndex));
            ArrayNode _replicasArray = new ArrayNode(JsonNodeFactory.instance);
            for (Integer _element : _object.replicas) {
                _replicasArray.add(new IntNode(_element));
            }
            _node.set("replicas", _replicasArray);
            ArrayNode _addingReplicasArray = new ArrayNode(JsonNodeFactory.instance);
            for (Integer _element : _object.addingReplicas) {
                _addingReplicasArray.add(new IntNode(_element));
            }
            _node.set("addingReplicas", _addingReplicasArray);
            ArrayNode _removingReplicasArray = new ArrayNode(JsonNodeFactory.instance);
            for (Integer _element : _object.removingReplicas) {
                _removingReplicasArray.add(new IntNode(_element));
            }
            _node.set("removingReplicas", _removingReplicasArray);
            return _node;
        }
    }
    
    public static class OngoingTopicReassignmentJsonConverter {
        public static OngoingTopicReassignment read(JsonNode _node, short _version) {
            OngoingTopicReassignment _object = new OngoingTopicReassignment();
            JsonNode _nameNode = _node.get("name");
            if (_nameNode == null) {
                throw new RuntimeException("OngoingTopicReassignment: unable to locate field 'name', which is mandatory in version " + _version);
            } else {
                if (!_nameNode.isTextual()) {
                    throw new RuntimeException("OngoingTopicReassignment expected a string type, but got " + _node.getNodeType());
                }
                _object.name = _nameNode.asText();
            }
            JsonNode _partitionsNode = _node.get("partitions");
            if (_partitionsNode == null) {
                throw new RuntimeException("OngoingTopicReassignment: unable to locate field 'partitions', which is mandatory in version " + _version);
            } else {
                if (!_partitionsNode.isArray()) {
                    throw new RuntimeException("OngoingTopicReassignment expected a JSON array, but got " + _node.getNodeType());
                }
                ArrayList<OngoingPartitionReassignment> _collection = new ArrayList<OngoingPartitionReassignment>();
                _object.partitions = _collection;
                for (JsonNode _element : _partitionsNode) {
                    _collection.add(OngoingPartitionReassignmentJsonConverter.read(_element, _version));
                }
            }
            return _object;
        }
        public static JsonNode write(OngoingTopicReassignment _object, short _version) {
            ObjectNode _node = new ObjectNode(JsonNodeFactory.instance);
            _node.set("name", new TextNode(_object.name));
            ArrayNode _partitionsArray = new ArrayNode(JsonNodeFactory.instance);
            for (OngoingPartitionReassignment _element : _object.partitions) {
                _partitionsArray.add(OngoingPartitionReassignmentJsonConverter.write(_element, _version));
            }
            _node.set("partitions", _partitionsArray);
            return _node;
        }
    }
}
